#include <cstdio>

#include "thing.hh"
#include "dynpool.hh"

int main(void)
{
	dynpool pool;
	
	pool.load("./libmama.so");
	pool.load("./libpapa.so");
	
	std::printf("\nTesting Papa.\n");
	
	/* Another way of invocation */
	Thing *t2 = (Thing *)pool.find("Papa")->maker();
	t2->Wave();
	delete t2;
	
	pool.unregister("Papa");

	for(unsigned a=0; a<pool.size(); ++a)
	{
		const dynpool::ent ent = pool[a];
		
		std::printf("\nGetting '%s'\n", ent.name);
		
		switch(ent.basetype)
		{
			case BASETYPE_THING:
			{
				Thing *t = (Thing *) ent.maker();
				t->Wave();
				delete t;
				break;
			}
			default:
				std::printf("Oops! Unknown type?? %d\n", ent.basetype);
		}
	}

	return 0;
}
